Public Class ZKListenLaden


    Private Sub ZKListenLaden_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load, MyBase.Activated, MyBase.Shown

        txZKListPath.Text = m_sZKListPath

    End Sub


    Private Sub btZKListenLaden_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btZKListenLaden.Click

    End Sub


    Private Sub btZKListenLesen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btZKListenLesen.Click

        ' In diesem Verzeichnis werden die gelesene Listendaten gesichert
        Dim szCurrentDir As String
        ' Default Speicherort ist immer das Programmverzeichnis
        szCurrentDir = System.Environment.CurrentDirectory.ToString
        ' Default werden die Daten immer im ASCII *.txt Format abgelegt
        Dim szExtention As String
        szExtention = ".txt"
        ' Name der Datensatzbeschreibung
        Dim szFileName As String

        If (ListPathDlg.ShowDialog() = Windows.Forms.DialogResult.OK) Then
            szCurrentDir = ListPathDlg.SelectedPath.ToString
            txReadZKList.Text = szCurrentDir
            txReadZKList.Update()
            m_sSaveListPath = szCurrentDir

            ' Vorbereitung fr anzuzeigende Messageboxen
            Dim style As MsgBoxStyle
            Dim style2 As MsgBoxStyle
            '   Dim response As MsgBoxResult
            style = MsgBoxStyle.Exclamation Or MsgBoxStyle.OkOnly
            style2 = MsgBoxStyle.Exclamation Or MsgBoxStyle.YesNo

            Dim nComError As Integer
            Dim szComError As String
            Dim cErrorLength(255) As Char
            szComError = New String(cErrorLength)
            Dim szLinkTyp As String
            Dim MsgTitle As String
            Dim MsgStyle As MsgBoxStyle
            MsgStyle = MsgBoxStyle.Critical Or MsgBoxStyle.OkOnly
            MsgTitle = ""
            szLinkTyp = ""
            RichDataBox.Text = ""

            ' Zuerst alles aufrumen
            RichDataBox.Clear()

            Dim iDFComResult As Integer ' Rckgabewert der DFComDLL Funktionsaufrufe

            Dim LDName As String ' Name eine Listenbeschreibung
            Dim LDField As String ' Name eines Feldes
            Dim length(33) As Char
            LDName = New String(length) ' Bereitstellung des Speichers
            LDField = New String(length) ' Bereitstellung des Speichers

            '********************************************************************************
            ' Hier werden die Listendefinitionen ausgelesen und in den Strukturen gespeichert
            GetZKListDefinition(RichDataBox)

            ' Nur zur Abgrenzung des Feedbacks in der Ausgabe eine Leerzeile einfgen
            RichDataBox.AppendText(vbCrLf)

            '********************************************************************************
            ' Jetzt knnen die Listen aus dem Gert gelesen werden
            Dim l_nListHandle As Integer
            Dim l_sListName As String
            '           Dim l_sErrorInfo As String
            Dim l_sFieldValue As String
            Dim l_nValueLength As Integer

            ' Wir haben jetzt alle Daten, die wir bentigen und knnen jetzt die Listendaten aus dem Gert lesen
            For listcount As Integer = 0 To GlobalDefs.ZKLDCount - 1
                ' Handle auf eine Liste ermitteln
                l_sListName = "ACCESS." & STLZK(listcount).LiName
                Select Case m_nLinkDLLType
                    Case 1 ' Declare
                        iDFComResult = CallingVariations.DFCOpenTable_Declare(1, 254, l_sListName, 0, l_nListHandle, "", nComError)
                    Case 2 ' Import
                    Case 3 ' Unicode
                    Case 4 ' ANSI 
                        iDFComResult = CallingVariations.DFCOpenTable_ANSI(1, 254, l_sListName, 0, l_nListHandle, "", nComError)
                    Case 5 ' Auto
                End Select
                ' Hier wird der Pfad fr die Dateiablage der Listen zusammengestellt!
                Dim pos As Integer
                pos = STLZK(listcount).LiName.ToString.Length()
                szFileName = STLZK(listcount).LiName.Substring(0, pos)
                szFileName = szCurrentDir & "\" & szFileName & ".txt"

                ' Wenn die Datei fr entsprechend der Datensatzbeschreibung
                ' fr die Daten noch nicht existiert, dann erstellen
                ' Schreibobjekt erzeugen
                Dim objStreamWriter As System.IO.StreamWriter


                If (iDFComResult = 1) Then

                    If (nComError = 0) Then

                        ' *****************************************************
                        ' ***!!! Eine bestehende Datei wird berschieben !!!***
                        ' *****************************************************
                        ' Wenn die Datei nicht existiert, wird sie erzeugt
                        objStreamWriter = New System.IO.StreamWriter(szFileName, False)

                        RichDataBox.AppendText("ZK-Liste: ")
                        RichDataBox.AppendText(STLZK(listcount).LiName)
                        RichDataBox.AppendText(vbCrLf)
                        ' Eine Liste ist offen und der Datensatzzeiger steht auf Position 0 = erster Datensatz

                        Dim szDatensatz As String
                        szDatensatz = Space(255)
                        Trim(szDatensatz)
                        objStreamWriter.Write(";")
                        For fieldcount As Integer = 0 To STLZK(listcount).LiFieldCount - 1
                            ' Einmal alle Feldbezeichner in die Datei als Spaltenberschrift schreiben
                            RichDataBox.AppendText(STLZK(listcount).LiFields(fieldcount).FiName)
                            RichDataBox.AppendText(vbTab)
                            objStreamWriter.Write(STLZK(listcount).LiFields(fieldcount).FiName.ToString.Substring(0, STLZK(listcount).LiFields(fieldcount).FiName.ToString.ToString.Length()))
                            objStreamWriter.Write(vbTab)
                        Next

                        ' Hier die Daten in die Datei schreiben
                        objStreamWriter.Write(vbCrLf)
                        RichDataBox.AppendText(vbCrLf)

                        Do While iDFComResult = 1

                            For fieldcount As Integer = 0 To STLZK(listcount).LiFieldCount - 1
                                ' Jetzt lesen wir die Fehlder der Reihenach aus
                                l_sFieldValue = StrDup(STLZK(listcount).LiFields(fieldcount).FiLength, Chr(0))

                                iDFComResult = CallingVariations.DFCGetField_Declare(1, 254, l_nListHandle, STLZK(listcount).LiFields(fieldcount).FiName, l_sFieldValue, l_nValueLength, nComError)
                                If (iDFComResult = 1) Then
                                    RichDataBox.AppendText(l_sFieldValue)
                                    RichDataBox.AppendText(vbTab)
                                    If (l_nValueLength = 0) Then
                                        l_sFieldValue = " " & Chr(0)
                                    End If
                                    If (l_sFieldValue.IndexOf(Chr(0)) = -1) Then
                                        objStreamWriter.Write(l_sFieldValue)
                                    Else
                                        objStreamWriter.Write(Microsoft.VisualBasic.Left(l_sFieldValue, l_sFieldValue.IndexOf(Chr(0))))
                                    End If
                                    objStreamWriter.Write(vbTab)
                                Else

                                End If
                            Next
                            ' Hier die Daten in die Datei schreiben
                            objStreamWriter.Write(vbCrLf)
                            RichDataBox.AppendText(vbCrLf)
                            RichDataBox.ScrollToCaret()

                            iDFComResult = CallingVariations.DFCSkip_Declare(1, 254, l_nListHandle, 1, 1, nComError)
                        Loop

                        objStreamWriter.Close()

                    End If

                Else
                    ' Der Rckgabewert von DFCUpload_... ist 0.
                    ' Hier geben wir den aufgetretenen Fehler aus
                    ' Wir suchen nach der ersten Position der Endekennung
                    ' Dim pos As Integer
                    'pos = STLZK(listcount).LiName.ToString.Length()
                    'l_sErrorInfo = "ZK-Liste " & STLZK(listcount).LiName.Substring(0, pos)
                    'CallExseptionInfo(Convert.ToInt32(1), nComError, 0, szComError, szComError.Length(), MsgStyle, "Fehler bei DFCUpload", m_sLinkDLLType, l_sErrorInfo)
                End If
                ' Wenn wir die Daten geschrieben haben, dann die Datei noch schlieen

                RichDataBox.AppendText(vbCrLf)
                ' Jede geffnete Liste muss auch wieder geschlossen werden
                CallingVariations.DFCCloseTable_Declare(1, 254, l_nListHandle, nComError)

            Next

        End If

    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Dim nComError As Integer
        Dim tm As String
        Dim ma As Integer
        Dim tp As Integer
        Dim dr As Integer

        tm = _tbTM.Text
        ma = Convert.ToInt32(_tbMask.Text)
        tp = Convert.ToInt32(_tbType.Text)
        dr = Convert.ToInt32(_tbDuration.Text)

        If (CallingVariations.DFCEntrance2OnlineAction_Declare(1, 254, tm, ma, tp, dr, nComError) = 0) Then

            MessageBox.Show("Fehler bei Ausfhrung\nEntrance2OnlineAction\n" + Convert.ToString(nComError), "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)

        End If

    End Sub

    Private Sub _btOnlineBuchung_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles _btOnlineBuchung.Click
        Dim nComError As Integer
        Dim tm As String
        Dim id As String
        Dim pin As String
        Dim state As String
        Dim nLen As Integer
        Dim length(5) As Char
        nLen = 5
        state = New String(length)

        tm = _tbOBTM.Text
        id = _tbOBAusweis.Text
        pin = _tbOBPIN.Text

        If (CallingVariations.DFCEntrance2Identification_Declare(1, 254, tm, id, pin, state, nLen, nComError) = 0) Then

            MessageBox.Show("Fehler bei Ausfhrung in \nEntrance2Identification\n" + Convert.ToString(nComError), "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)

        End If

    End Sub
End Class