Public Class AktiveConnect

    Public reqestChannel As Integer

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click

        Dim nComError As Integer
        Dim nResult As Integer

        nResult = CallingVariations.DFCStartActiveConnection_Declare("192.168.123.142", 8000, 31, 3000, 10, 10, 0, 0, nComError)

        If (nResult = 0) Then

            MessageBox.Show("Fehler bie DFCStartAktiveConnection mit Code: " + nComError.ToString)

        End If

    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        Dim nComError As Integer
        Dim nResult As Integer

        nResult = CallingVariations.DFCStopActiveConnection_Declare(nComError)

        If (nResult = 0) Then

            MessageBox.Show("Fehler bie DFCStopActiveConnection mit Code: " + nComError.ToString)

        Else

            MessageBox.Show("DFCStopActiveConnection erfolgreich, Code: " + nComError.ToString)

        End If


    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click

        Dim nResult As Integer
        Dim count As Integer

        count = _cbActiveChannel.Items.Count
        nResult = CallingVariations.DFCGetFirstActiveChannelID_Declare()

        If (nResult > 0 And count = 1) Then
            _cbActiveChannel.Items.Insert(count, "Kanal-Nr: " + nResult.ToString())
            _cbActiveChannel.SelectedIndex = count
        End If


    End Sub

    Private Sub AktiveConnect_Activated(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Activated

        Dim count As Integer

        count = _cbActiveChannel.Items.Count

        If (count > 0) Then
            _cbActiveChannel.SelectedIndex = 0
        End If


    End Sub

    Private Sub Button5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button5.Click

        Dim nResult As Integer
        Dim count As Integer
        Dim lastChannel As Integer
        Dim channel As String

        count = _cbActiveChannel.Items.Count
        channel = _cbActiveChannel.Items.Item(count - 1).ToString
        If (count > 1) Then

            lastChannel = Convert.ToInt16(channel.Substring(channel.IndexOf(" "), (channel.Length - channel.IndexOf(" "))))

            nResult = CallingVariations.DFCGetNextActiveChannelID_Declare(lastChannel)

            If (nResult > 0) Then
                _cbActiveChannel.Items.Insert(count, "Kanal-Nr: " + nResult.ToString())
                _cbActiveChannel.SelectedIndex = count
            End If

        End If


    End Sub

    Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.Click

        Dim sLength As Integer
        Dim length(255) As Char
        Dim Info As String
        Info = New String(length)
        sLength = 255

        If (CallingVariations.DFCGetInfoActiveChannel_Declare(reqestChannel, Info, sLength)) Then

            _rtbInfoChannel.AppendText(Info.ToString)

        Else
            MessageBox.Show("Fehler bei der Ausfhrung von GetInfoActiveChannel")
        End If



    End Sub

    Private Sub _cbActiveChannel_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles _cbActiveChannel.SelectedIndexChanged

        Dim index As Integer
        Dim channel As String

        index = _cbActiveChannel.SelectedIndex
        If index > 0 Then
            channel = _cbActiveChannel.Items.Item(index).ToString
            reqestChannel = Convert.ToInt16(channel.Substring(channel.IndexOf(" "), (channel.Length - channel.IndexOf(" "))))
        End If

    End Sub
End Class