#include "StdAfx.h"
#include "DFFileIntelHex.h"

CDFFileIntelHex::CDFFileIntelHex(void)
{
	// Initialisieren
	ResetError();
	Reset();
}

CDFFileIntelHex::~CDFFileIntelHex(void)
{
}

char *CDFFileIntelHex::GetErrorText(int errorState)
{
	if (errorState == -1) {

		errorState = m_errorState;
	}

	switch(errorState) {
	case ES_NO:
		sprintf(m_errorText, "(%i): %s", errorState, ES_NO_TEXT);
		break;
	case ES_FILE_OPEN:
		sprintf(m_errorText, "(%i): %s", errorState, ES_FILE_OPEN_TEXT);
		break;
	case ES_CRC_FAIL:
		sprintf(m_errorText, "(%i): %s", errorState, ES_CRC_FAIL_TEXT);
		break;
	case ES_FORMAT:
		sprintf(m_errorText, "(%i): %s", errorState, ES_FORMAT_TEXT);
		break;
	case ES_NO_DATA:
		sprintf(m_errorText, "(%i): %s", errorState, ES_NO_DATA_TEXT);
		break;
	case ES_LOAD_DISPLAY_DATA:
		sprintf(m_errorText, "(%i): %s", errorState, ES_LOAD_DISPLAY_DATA_TEXT);
		break;
	case ES_LOAD_DEVICE_TEXT:
		sprintf(m_errorText, "(%i): %s", errorState, ES_LOAD_DEVICE_TEXT_TEXT);
		break;
	case ES_DEVICE_UNKNOWN:
		sprintf(m_errorText, "(%i): %s", errorState, ES_DEVICE_UNKNOWN_TEXT);
		break;
	case ES_PROGRAM_OVERFLOW:
		sprintf(m_errorText, "(%i): %s", errorState, ES_PROGRAM_OVERFLOW_TEXT);
		break;
	case ES_INTELHEX_MAKE_RECORD:
		sprintf(m_errorText, "(%i): %s", errorState, ES_INTELHEX_MAKE_RECORD_TEXT);
		break;
	case ES_CRYPT_FIXFAIL:
		sprintf(m_errorText, "(%i): %s", errorState, ES_CRYPT_FIXFAIL_TEXT);
		break;
	case ES_CRYPT_NONE:
		sprintf(m_errorText, "(%i): %s", errorState, ES_CRYPT_NONE_TEXT);
		break;
	case ES_CRYPT_IS:
		sprintf(m_errorText, "(%i): %s", errorState, ES_CRYPT_IS_TEXT);
		break;
	case ES_INI_KEY:
		sprintf(m_errorText, "(%i): %s", errorState, ES_INI_KEY_TEXT);
		break;
	case ES_INI_KEY_VALUE:
		sprintf(m_errorText, "(%i): %s", errorState, ES_INI_KEY_VALUE_TEXT);
		break;
	case ES_SIZE:
		sprintf(m_errorText, "(%i): %s", errorState, ES_SIZE_TEXT);
		break;
	case ES_VERSION:
		sprintf(m_errorText, "(%i): %s", errorState, ES_VERSION_TEXT);
		break;
	case ES_INTEL_HEX:
		sprintf(m_errorText, "(%i): %s", errorState, ES_INTEL_HEX_TEXT);
		break;
	case ES_HEAD_CRC:
		sprintf(m_errorText, "(%i): %s", errorState, ES_HEAD_CRC_TEXT);
		break;
	case ES_FW_VERSION_LENGTH:
		sprintf(m_errorText, "(%i): %s", errorState, ES_FW_VERSION_LENGTH_TEXT);
		break;
	case ES_PROGRAM_CRC:
		sprintf(m_errorText, "(%i): %s", errorState, ES_PROGRAM_CRC_TEXT);
		break;
	case ES_FUNCTION_UNAVAILABLE:
		sprintf(m_errorText, "(%i): %s", errorState, ES_FUNCTION_UNAVAILABLE_TEXT);
		break;
	case ES_LOAD_RAW_FIRMWARE:
		sprintf(m_errorText, "(%i): %s", errorState, ES_LOAD_RAW_FIRMWARE_TEXT);
		break;
	case ES_VERSION_FILE:
		sprintf(m_errorText, "(%i): %s", errorState, ES_VERSION_FILE_TEXT);
		break;
	case ES_AS_TEXT:
		sprintf(m_errorText, "(%i): %s", errorState, ES_AS_TEXT_TEXT);
		break;
	case ES_FILE_FORMAT:
		sprintf(m_errorText, "(%i): %s", errorState, ES_FILE_FORMAT_TEXT);
		break;
	case ES_LINE_FORMAT:
		sprintf(m_errorText, "(%i): %s", errorState, ES_LINE_FORMAT_TEXT);
		break;
	case ES_ALLOC_MEM:
		sprintf(m_errorText, "(%i): %s", errorState, ES_ALLOC_MEM_TEXT);
		break;
	default:
		sprintf(m_errorText, "(%i): %s", errorState, "Unbekannter Fehler.");
	}

	return m_errorText;
}