// DFItemDevice.h: Schnittstelle fr die Klasse CDFItemDevice.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_DFITEMDEVICE_H__09C47231_3893_48C0_80E0_65B1C73B25DF__INCLUDED_)
#define AFX_DFITEMDEVICE_H__09C47231_3893_48C0_80E0_65B1C73B25DF__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

// Basisklasse einbinden
#include "DFItemBase.h"
#include <math.h>
#include "DFItemAccessControl.h"
#include "DFItemAccessControl2.h"
#include "DFItemHandling.h"
#include "DFItemMDE.h"
#include "DFItemTableList.h"
#include "DFItemTableRecord.h"

class CDFItemDevice : public CDFItemBase  
{
public:
	CDFItemDevice(NodeTypeID _type = DEVICE);
	virtual ~CDFItemDevice();
	
public:
	/// Veraendern der Daten von der geladenen Studiodatei. 
	int Modify(CModifyData &modifyData);

	inline unsigned long HexToUINT32(char *value, unsigned char digits = 255) 
	{
		unsigned long val=0;
		unsigned char len = (digits > strlen(value)) ? strlen(value) : digits;

		for (int i=1; i <= len; i++) {
			if ((value[len - i] >= '0') && (value[len - i] <= '9')) {
				val += (unsigned long)((value[len - i] - '0') * (double)pow((double)16, (double)i-1));
			} else if ((value[len - i] >= 'a') && (value[len - i] <= 'f')) {
				val += (unsigned long)((10 + value[len - i] - 'a') * (double)pow((double)16, (double)i-1));
			} else if ((value[len - i] >= 'A') && (value[len - i] <= 'F')) {
				val += (unsigned long)((10 + value[len - i] - 'A') * (double)pow((double)16, (double)i-1));
			} else {
				return val;
			}
		}

		return val;
	}
};

#endif // !defined(AFX_DFITEMDEVICE_H__09C47231_3893_48C0_80E0_65B1C73B25DF__INCLUDED_)
